# -*- coding: utf-8 -*-
"""
Created on Mon May 30 08:25:18 2022

@author: claverad
"""

import graphviz
import numpy as np
import random as rd
import matplotlib.pyplot as plt
from sklearn.cluster import KMeans
import time
from sklearn.tree import DecisionTreeRegressor
import pandas as pd
from sklearn import tree
from sklearn.model_selection import train_test_split
from sklearn import metrics


data = pd.read_csv(
    'Z:/GESTION ENERGIE/S3_Python_Database/Chauffage.csv', sep=",")
print("jfjkjjkl",data.isnull().sum())
data.ffill()
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_new = data.resample('30T').pad()
data_new['value']=data_new['value'].fillna(0)

#Temps_chauffage= [data_new[:,0]]
# val_chauffage= [data_new[:,1]]


print((data_new))
Donnee_chau = data_new["value"]



data1 = pd.read_csv('Z:/GESTION ENERGIE/S3_Python_Database/Text1.csv', sep=",")
data1['time'] = pd.to_datetime(data1['time'])
pd.to_datetime(data1['time'], format='%Y-%m-%dT%H:%M:%S')
data1.set_index('time', inplace=True)
data_new1 = data1.resample('30T').mean()
data_new1['value']=data_new1['value'].fillna(7)
print((data_new1))
# Temps_chauffage= [data_new[:,0]]
# val_chauffage= [data_new[:,1]]

Donnee_Text = data_new1["value"]


data2 = pd.read_csv('Z:/GESTION ENERGIE/S3_Python_Database/Trdc1.csv', sep=",")
data2['time'] = pd.to_datetime(data2['time'])
pd.to_datetime(data2['time'], format='%Y-%m-%dT%H:%M:%S')
data2.set_index('time', inplace=True)
data_new2 = data2.resample('30T').mean()
data_new2['value']=data_new2['value'].fillna(21)
print((data_new2))
Donnee_Trdc = data_new2["value"]

temps=np.linspace(0,28,1296)
plt.plot(temps,Donnee_chau,label='chauffage')
plt.plot(temps,data_new1,label='Température Extérieure')
plt.plot(temps,data_new2,label='Température Intérieur')

plt.title('Evolution de la température en fonction du temps ')
plt.xlabel('Jours en Février 2022')
plt.ylabel('Température en degré')
plt.legend()
plt.show()
# Temps_chauffage= [data_new[:,0]]
# val_chauffage= [data_new[:,1]]



# for i in range(len(Donnee_Text)):
#     print(Donnee_Text[i])

feature = []

taille_training = int(0.7*len(Donnee_Trdc))

X = []
Y = []

for i in range(taille_training):
    feature = [Donnee_chau[i], Donnee_Text[i]]
    X.append(feature)
    Y.append(Donnee_Trdc[i])

taille_tempRDC = len(Donnee_Trdc)

print (taille_training)
print (taille_tempRDC)
Xnew=[]
Xcluster=[]
for i in range(taille_training, taille_tempRDC-1):
    feature = [Donnee_chau[i], Donnee_Text[i]]
    Xcluster.append((feature[1],feature[0]))
    Xnew.append(feature)


Ymod = classifier.predict(Xnew)

Yref = []

for i in range(taille_training, taille_tempRDC):
    Yref.append(Donnee_Trdc[i])


regr = DecisionTreeRegressor(max_depth=3)
regr.fit(X, Y)
y = regr.predict(X)

with open("tree23.dot", 'w') as file:
    f = tree.export_graphviz(regr, out_file=file)

plt.plot(y, label="max_depth=5")
plt.xlabel("features")
plt.ylabel("tempRDC")
plt.show()

m = len(Yref)-1
vrai = 0
faux = 0


for i in range(m):
    if Yref[i]==Ymod[i]:
        vrai += 1
    else:
        faux+= 1
print ("Le modele donne le nb exact à :", ((vrai/m)*100,"%"))

error=[]
somme=0
erreur_moy=0

for i in range(m):
    if Yref[i]!=0:
        error_i=abs((Yref[i]-Ymod[i])/Yref[i])
    else:
        if Ymod[i]==0:
            error_i=0
        else:
            error_i=Ymod[i]

    error.append(error_i)
    somme+=error[i]
    erreur_moy=somme/m


print("L'erreur moyenne vaut: \n")
print(erreur_moy)

importance= classifier.feature_importances_
for i,v in enumerate(importance):
    print('Feature: %0d, Score: %.5f' % (i,v))

plt.title("Most important feature")
plt.bar([x for x in range(len(importance))], importance)
#plt.show()


kmeans = KMeans(n_clusters=5, random_state=0).fit(X)

print(kmeans.labels_)
print(kmeans.cluster_centers_)

print(Xnew)
k=[]
error_ie=0
for i in range(0,216):
    k.append(kmeans.predict([X[i]])[0])
if Yref[i]!=0:
    error_ie = abs((Yref[i] - k[i]) / Yref[i])
    if k[i]==0:
        error_ie=0
    else:
        error_ie=k[i]
vrai2=0
faux2=0

for i in range(0,216):
    if Yref[i]==k[i]:
        vrai2 += 1
    else:
        faux2+= 1
    error.append(error_ie)
    somme += error[i]
erreur_moy = somme / m
print ("Le modele donne le nb exact à :", ((vrai2/216)*100,"%"))
print(k)

print(erreur_moy)
